datablock StaticShapeData(AxisShape)
{
	shapeFile = $CurrMod_BasePath @ "Models/Axis.dts";
};

datablock StaticShapeData(ToolTranslateShape)
{
	shapeFile = $CurrMod_BasePath @ "Models/Tool_Translate.dts";
};

datablock StaticShapeData(ToolRotateShape)
{
	shapeFile = $CurrMod_BasePath @ "Models/Tool_Rotate.dts";
};

datablock StaticShapeData(ToolScaleShape)
{
	shapeFile = $CurrMod_BasePath @ "Models/Tool_Scale.dts";
};

package blenderTools
{
	function Armor::onTrigger(%data, %this, %trig, %tog)
	{
		Parent::onTrigger(%data, %this, %trig, %tog);
		if (%trig == 4 && %tog == 0 && vectorDist(%this.triggerTime4, getSimTime()) < 250)
			%doSelect = 1;
		if (%tog)
			%this.triggerTime[%trig] = getSimTime();
		else
			%this.triggerTime[%trig] = "";
		if (%doSelect)
		{
			%scene = %this.getControllingClient().scene;
			if (!isObject(%scene))
				%scene = BlenderScene;
			%eye = %this.getEyePoint();
			%vec = %this.getEyeVector();
			%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%vec, 240)), $Typemasks::StaticShapeObjectType);
			if (isObject(%ray))
			{
				%hit = firstWord(%ray);
				if (!%scene.objects.isMember(%hit) && !%hit.getGroup().scene.request(%scene, %hit))
					return;
				%scene.select(%hit, %this.triggerTime3 !$= "");
			}
		}
	}
	function Observer::onTrigger(%data, %this, %trig, %tog)
	{
		Parent::onTrigger(%data, %this, %trig, %tog);
		if (%trig == 4 && %tog == 0 && vectorDist(%this.triggerTime4, getSimTime()) < 250)
			%doSelect = 1;
		if (%tog)
			%this.triggerTime[%trig] = getSimTime();
		else
			%this.triggerTime[%trig] = "";
		if (%doSelect)
		{
			%scene = %this.getControllingClient().scene;
			if (!isObject(%scene))
				%scene = BlenderScene;
			%eye = %this.getEyePoint();
			%vec = %this.getEyeVector();
			%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%vec, 240)), $Typemasks::StaticShapeObjectType);
			if (isObject(%ray))
			{
				%hit = firstWord(%ray);
				if (!%scene.objects.isMember(%hit) && !%hit.getGroup().scene.request(%scene, %hit))
					return;
				%scene.select(%hit, %this.triggerTime3 !$= "");
			}
		}
	}
};
activatePackage("blenderTools");

function createBlenderTool()
{
	%tool = new StaticShape()
	{
		datablock = ToolTranslateShape;
		scale = "2 2 2";
	};
	%tool.axis = new StaticShape()
	{
		datablock = AxisShape;
		scale = "2 2 2";
	};
	%tool.axis.hideNode("ALL");
	%tool.setNodeColor("TranslateX", "0.863 0 0 1");
	%tool.setNodeColor("TranslateY", "0 0.863 0 1");
	%tool.setNodeColor("TranslateZ", "0 0 0.863 1");
	BlenderToolLoop(%tool, getSimTime());
	%tool.currMode = "translate";
	return %tool;
}

function BlenderToolLoop(%tool, %last, %grabber, %handle)
{
	if (!isObject(%tool))
		return;
	if (!%tool.active)
	{
		schedule(16, 0, "BlenderToolLoop", %tool, %now);
		return;
	}
	%now = getSimTime();
	if (%tool.currMode $= "rotate")
	{
		if (!isObject(%grabber))
		{
			%clients = ClientGroup.getCount();
			for (%i = 0; %i < %clients; %i++)
			{
				%client = ClientGroup.getObject(%i);
				%scene = %client.scene;
				if (!isObject(%scene))
					%scene = BlenderScene;
				if (%scene != %tool.scene)
					continue;
				if (!isObject(%obj = %client.getControlObject()))
					continue;
				if (%obj.triggerTime0 $= "" || %obj.triggerTime0 < %last)
					continue;
				%eye = %obj.getEyePoint();
				%vec = %obj.getEyeVector();
				%pos = %tool.getPosition();
				for (%j = 0; %j < 3; %j++)
				{
					%dist = (getWord(%pos, %j) - getWord(%eye, %j)) / getWord(%vec, %j);
					if (%dist < 0)
						continue;
					%ringPos = vectorSub(%pos, vectorAdd(%eye, vectorScale(%vec, %dist)));
					%aim = mAbs(2 - vectorLen(%ringPos));
					if (%aim < 0.2 && (%aim < %best || %best $= ""))
					{
						%grab = %j;
						%best = %aim;
						%aimPos = %ringPos;
					}
				}
				if (%grab !$= "")
				{
					%grabber = %client;
					%handle = %grab;
					%tool.user = %grabber;
					%tool.hideNode("ALL");
					%tool.axis.unhideNode("ALL");
					%tool.axis.setNodeColor("ALL", setWord("0.392 0.392 0.392 1", %handle, 0.824));
					%tool.axis.setTransform(%tool.realPosition SPC VectorToRotation(setWord("0 0 0", %handle, 1)));
					%startAngle = mAtan(getWord(%aimPos, %handle == 0), getWord(%aimPos, 1 + (%handle <= 1)));
					schedule(16, 0, "BlenderToolLoop", %tool, %now, %grabber, %handle);
					%tool.startAng = %startAngle;
					return;
				}
			}
		}
		else
		{
			if (!isObject(%obj = %grabber.getControlObject()))
			{
				%tool.unhideNode("ALL");
				%tool.axis.hideNode("ALL");
				%tool.user = "";
				schedule(16, 0, "BlenderToolLoop", %tool, %now);
				return;
			}
			%eye = %obj.getEyePoint();
			%vec = %obj.getEyeVector();
			%pos = %tool.getPosition();
			%dist = (getWord(%pos, %handle) - getWord(%eye, %handle)) / getWord(%vec, %handle);
			if (%dist < 0)
			{
				schedule(16, 0, "BlenderToolLoop", %tool, %now, %grabber, %handle);
				return;
			}
			%aimPos = vectorSub(%pos, vectorAdd(%eye, vectorScale(%vec, %dist)));
			%newAngle = mAtan(getWord(%aimPos, %handle == 0), getWord(%aimPos, 1 + (%handle <= 1)));
			%delta = %newAngle - %tool.startAng;
			if (%obj.triggerTime3 !$= "")
				%delta = mFloatLength(%delta / $PI * 36, 0) / 36 * $PI;
			if (%obj.triggerTime0 $= "")
			{
				%tool.unhideNode("ALL");
				%tool.axis.hideNode("ALL");
				%tool.user = "";
				%objs = %tool.scene.objects;
				%count = %objs.getCount();
				for (%i = 0; %i < %count; %i++)
				{
					%obj = %objs.getObject(%i);
					if (!%obj.selected)
						continue;
					%obj.setTransform(%obj.shapePosition SPC %obj.shapeRotation);
					%pos = vectorSub(%obj.shapePosition, %tool.realPosition);
					%for = %obj.getForwardVector();
					%up = %obj.getUpVector();
					%forOut = setWord(setWord(setWord("0 0 0", %handle == 0, getWord(%for, %handle == 0) * mCos(%delta) + getWord(%for, 1 + (%handle <= 1)) * mSin(%delta)),
						1 + (%handle <= 1), getWord(%for, 1 + (%handle <= 1)) * mCos(%delta) - getWord(%for, %handle == 0) * mSin(%delta)), %handle, getWord(%for, %handle));
					%upOut = setWord(setWord(setWord("0 0 0", %handle == 0, getWord(%up, %handle == 0) * mCos(%delta) + getWord(%up, 1 + (%handle <= 1)) * mSin(%delta)),
						1 + (%handle <= 1), getWord(%up, 1 + (%handle <= 1)) * mCos(%delta) - getWord(%up, %handle == 0) * mSin(%delta)), %handle, getWord(%up, %handle));
					%posOut = setWord(setWord(setWord("0 0 0", %handle == 0, getWord(%pos, %handle == 0) * mCos(%delta) + getWord(%pos, 1 + (%handle <= 1)) * mSin(%delta)),
						1 + (%handle <= 1), getWord(%pos, 1 + (%handle <= 1)) * mCos(%delta) - getWord(%pos, %handle == 0) * mSin(%delta)), %handle, getWord(%pos, %handle));
					%pos = vectorAdd(%posOut, %tool.realPosition);
					%obj.shapePosition = %pos;
					%obj.shapeRotation = VectorsToRotation(%forOut, %upOut);
					%obj.setTransform(%obj.shapePosition SPC %obj.shapeRotation);
					%obj.wireframe.setTransform(%obj.getTransform());
				}
				updateToolTransform(%tool);
				schedule(16, 0, "BlenderToolLoop", %tool, %now);
				return;
			}
			else
			{
				%objs = %tool.scene.objects;
				%count = %objs.getCount();
				for (%i = 0; %i < %count; %i++)
				{
					%obj = %objs.getObject(%i);
					if (!%obj.selected)
						continue;
					%obj.setTransform(%obj.shapePosition SPC %obj.shapeRotation);
					%pos = vectorSub(%obj.shapePosition, %tool.realPosition);
					%for = %obj.getForwardVector();
					%up = %obj.getUpVector();
					%forLen = vectorLen(setWord(%for, %handle, 0));
					%upLen = vectorLen(setWord(%up, %handle, 0));
					%forOut = setWord(setWord(setWord("0 0 0", %handle == 0, getWord(%for, %handle == 0) * mCos(%delta) + getWord(%for, 1 + (%handle <= 1)) * mSin(%delta)),
						1 + (%handle <= 1), getWord(%for, 1 + (%handle <= 1)) * mCos(%delta) - getWord(%for, %handle == 0) * mSin(%delta)), %handle, getWord(%for, %handle));
					%upOut = setWord(setWord(setWord("0 0 0", %handle == 0, getWord(%up, %handle == 0) * mCos(%delta) + getWord(%up, 1 + (%handle <= 1)) * mSin(%delta)),
						1 + (%handle <= 1), getWord(%up, 1 + (%handle <= 1)) * mCos(%delta) - getWord(%up, %handle == 0) * mSin(%delta)), %handle, getWord(%up, %handle));
					%posOut = setWord(setWord(setWord("0 0 0", %handle == 0, getWord(%pos, %handle == 0) * mCos(%delta) + getWord(%pos, 1 + (%handle <= 1)) * mSin(%delta)),
						1 + (%handle <= 1), getWord(%pos, 1 + (%handle <= 1)) * mCos(%delta) - getWord(%pos, %handle == 0) * mSin(%delta)), %handle, getWord(%pos, %handle));
					%pos = vectorAdd(%posOut, %tool.realPosition);
					%obj.setTransform(%pos SPC VectorsToRotation(%forOut, %upOut));
					%obj.wireframe.setTransform(%obj.getTransform());
				}
			}
		}
	}
	else
	{
		if (!isObject(%grabber))
		{
			%clients = ClientGroup.getCount();
			for (%i = 0; %i < %clients; %i++)
			{
				%client = ClientGroup.getObject(%i);
				%scene = %client.scene;
				if (!isObject(%scene))
					%scene = BlenderScene;
				if (%scene != %tool.scene)
					continue;
				if (!isObject(%obj = %client.getControlObject()))
					continue;
				if (%obj.triggerTime0 $= "" || %obj.triggerTime0 < %last)
					continue;
				%eye = %obj.getEyePoint();
				%vec = %obj.getEyeVector();
				%pos = %tool.getPosition();
				for (%j = 0; %j < 3; %j++)
				{
					%dist = getDistance_LineSegmentToLine(%pos, vectorAdd(%pos, setWord("0 0 0", %j, 2)), %eye, vectorAdd(%eye, %vec));
					if (%dist < 0.1 && (%dist < %best || %best $= ""))
					{
						%grab = %j;
						%best = %dist;
					}
					//%handle = setWord("0 0 0", %j, 1.55);
					//%dir = vectorNormalize(vectorSub(vectorAdd(%pos, %handle), %eye));
					//%ang = mAcos(vectorDot(%vec, %dir));
					//%deg = 2 / 180 * $PI;
					//if (%ang < %deg && (%ang < %best || %best $= ""))
					//{
					//	%grab = %j;
					//	%best = %ang;
					//}
				}
				if (%grab !$= "")
				{
					%grabber = %client;
					%handle = %grab;
					%tool.user = %grabber;
					%tool.hideNode("ALL");
					%tool.axis.unhideNode("ALL");
					%tool.axis.setNodeColor("ALL", setWord("0.392 0.392 0.392 1", %handle, 0.824));
					%tool.axis.setTransform(%tool.realPosition SPC VectorToRotation(setWord("0 0 0", %handle, 1)));
					%startPos = getClosestPoint_LineToLine(%pos, vectorAdd(%pos, setWord("0 0 0", %handle, 1)), %eye, vectorAdd(%eye, %vec));
					%startPos = setWord(%tool.realPosition, %handle, getWord(%startPos, %handle));
					schedule(16, 0, "BlenderToolLoop", %tool, %now, %grabber, %handle);
					%tool.startPos = %startPos;
					return;
				}
			}
		}
		else
		{
			if (!isObject(%obj = %grabber.getControlObject()))
			{
				%tool.unhideNode("ALL");
				%tool.axis.hideNode("ALL");
				%tool.user = "";
				schedule(16, 0, "BlenderToolLoop", %tool, %now);
				return;
			}
			%pos = %tool.getPosition();
			%eye = %obj.getEyePoint();
			%vec = %obj.getEyeVector();
			%newPos = getClosestPoint_LineToLine(%pos, vectorAdd(%pos, setWord("0 0 0", %handle, 1)), %eye, vectorAdd(%eye, %vec));
			%newPos = setWord(%tool.realPosition, %handle, getWord(%newPos, %handle));
			if (vectorDot(vectorSub(%newPos, %eye), %vec) <= 0)
			{
				schedule(16, 0, "BlenderToolLoop", %tool, %now, %grabber, %handle);
				return;
			}
			%delta = vectorSub(%newPos, %tool.startPos);
			if (%obj.triggerTime3 !$= "")
			{
				if (%tool.currMode $= "translate")
				{
					%snapPos = getWord(%tool.scene.selectedObject.shapePosition, %handle);
					%snap = %snapPos + getWord(%delta, %handle);
					%snap = mFloatLength(%snap * 4, 0) / 4;
					%delta = setWord(%delta, %handle, %snap - %snapPos);
				}
			}
			if (%obj.triggerTime0 $= "")
			{
				%tool.unhideNode("ALL");
				%tool.axis.hideNode("ALL");
				%tool.user = "";
				if (vectorDot(vectorSub(%newPos, %eye), %vec) > 0)
				{
					%objs = %tool.scene.objects;
					%count = %objs.getCount();
					for (%i = 0; %i < %count; %i++)
					{
						%obj = %objs.getObject(%i);
						if (!%obj.selected)
							continue;
						if (%tool.currMode $= "translate")
						{
							%obj.setTransform(vectorAdd(%obj.shapePosition, %delta));
							%obj.wireframe.setTransform(%obj.getPosition());
							%obj.shapePosition = %obj.getPosition();
						}
						else if (%tool.currMode $= "scale")
						{
							%origLen = vectorDist(%tool.realPosition, %tool.startPos);
							%newLen = vectorDist(%tool.realPosition, %newPos);
							%scalar = %newLen / %origLen;
							%handleDir = setWord("0 0 0", %handle, 1);
							%scaleMask = mAbs(vectorDot(vectorCross(%obj.getForwardVector(), %obj.getUpVector()), %handleDir))
								SPC mAbs(vectorDot(%obj.getForwardVector(), %handleDir)) SPC mAbs(vectorDot(%obj.getUpVector(), %handleDir));
							%scaleLen = 0;
							for (%j = 0; %j < 3; %j++)
								%scaleLen += getWord(%obj.shapeScale, %j) * getWord(%scaleMask, %j);
							if (%grabber.getControlObject().triggerTime3 !$= "")
							{
								%nScaleLen = mFloatLength(%scaleLen * %scalar * 4, 0) / 4;
								%scalar = %nScaleLen / %scaleLen;
							}
							%scalar -= 1;
							%scale = "0 0 0";
							for (%j = 0; %j < 3; %j++)
								%scale = setWord(%scale, %j, mAbs(getWord(%obj.shapeScale, %j) * (1 + %scalar * getWord(%scaleMask, %j))));
							%newShapePos = setWord(%obj.shapePosition, %handle, (getWord(%obj.shapePosition, %handle) - getWord(%tool.realPosition, %handle)) * (1 + %scalar) + getWord(%tool.realPosition, %handle));
							%obj.setScale(%scale);
							%obj.wireframe.setScale(%obj.getScale());
							%obj.setTransform(%newShapePos SPC %obj.shapeRotation);
							%obj.wireframe.setTransform(%obj.getTransform());
							%obj.shapeScale = %obj.getScale();
							%obj.shapePosition = %newShapePos;
						}
					}
					updateToolTransform(%tool);
				}
				schedule(16, 0, "BlenderToolLoop", %tool, %now);
				return;
			}
			else
			{
				if (vectorDot(vectorSub(%newPos, %eye), %vec) > 0)
				{
					if (%tool.currMode $= "translate")
						%tool.axis.setTransform(%newPos);
					%objs = %tool.scene.objects;
					%count = %objs.getCount();
					for (%i = 0; %i < %count; %i++)
					{
						%obj = %objs.getObject(%i);
						if (!%obj.selected)
							continue;
						if (%tool.currMode $= "translate")
						{
							%obj.setTransform(vectorAdd(%obj.shapePosition, %delta));
							%obj.wireframe.setTransform(%obj.getPosition());
						}
						else if (%tool.currMode $= "scale")
						{
							%origLen = vectorDist(%tool.realPosition, %tool.startPos);
							%newLen = vectorDist(%tool.realPosition, %newPos);
							%scalar = %newLen / %origLen;
							%handleDir = setWord("0 0 0", %handle, 1);
							%scaleMask = mAbs(vectorDot(vectorCross(%obj.getForwardVector(), %obj.getUpVector()), %handleDir))
								SPC mAbs(vectorDot(%obj.getForwardVector(), %handleDir)) SPC mAbs(vectorDot(%obj.getUpVector(), %handleDir));
							%scaleLen = 0;
							for (%j = 0; %j < 3; %j++)
								%scaleLen += getWord(%obj.shapeScale, %j) * getWord(%scaleMask, %j);
							if (%grabber.getControlObject().triggerTime3 !$= "")
							{
								%nScaleLen = mFloatLength(%scaleLen * %scalar * 4, 0) / 4;
								%scalar = %nScaleLen / %scaleLen;
							}
							%scalar -= 1;
							%scale = "0 0 0";
							for (%j = 0; %j < 3; %j++)
								%scale = setWord(%scale, %j, mAbs(getWord(%obj.shapeScale, %j) * (1 + %scalar * getWord(%scaleMask, %j))));
							%newShapePos = setWord(%obj.shapePosition, %handle, (getWord(%obj.shapePosition, %handle) - getWord(%tool.realPosition, %handle)) * (1 + %scalar) + getWord(%tool.realPosition, %handle));
							%obj.setScale(%scale);
							%obj.wireframe.setScale(%obj.getScale());
							%obj.setTransform(%newShapePos SPC %obj.shapeRotation);
							%obj.wireframe.setTransform(%obj.getTransform());
						}
					}
				}
			}
		}
	}
	schedule(16, 0, "BlenderToolLoop", %tool, %now, %grabber, %handle);
}

function updateToolTransform(%tool)
{
	%showPos = "0 0 0";
	%realPos = "0 0 0";
	%selectNum = 0;
	%objs = %tool.scene.objects;
	%count = %objs.getCount();
	for (%i = 0; %i < %count; %i++)
	{
		%obj = %objs.getObject(%i);
		if (!%obj.selected)
			continue;
		%realPos = vectorAdd(%realPos, %obj.getPosition());
		if (%obj.wireframe == %obj)
			%showPos = vectorAdd(%showPos, %obj.getPosition());
		else
			%showPos = vectorAdd(%showPos, setWord(%obj.getPosition(), 2, getWord(%obj.getWorldBox(), 5) + 2));
		%selectNum++;
	}
	if (%selectNum > 0)
	{
		%showPos = vectorScale(%showPos, 1 / %selectNum);
		%realPos = vectorScale(%realPos, 1 / %selectNum);
	}
	%tool.active = %selectNum > 0;
	%tool.setTransform(%showPos);
	%tool.realPosition = %realPos;
}

function getClosestPoint_LineToPoint(%start, %end, %point)
{
	%sp = vectorSub(%point, %start);
	%se = vectorSub(%end, %start);
	%se2 = vectorDot(%se, %se);
	%sp_se = vectorDot(%sp, %se);
	%t = mClampF(%sp_se / %se2, 0, 1);
	return vectorAdd(%start, vectorScale(%se, %t));
}

function getClosestPoint_LineToLine(%lStart0, %lEnd0, %lStart1, %lEnd1)
{
	%u = vectorSub(%lEnd0, %lStart0);
	%v = vectorSub(%lEnd1, %lStart1);
	%w = vectorSub(%lStart0, %lStart1);
	%a = vectorDot(%u, %u);
	%b = vectorDot(%u, %v);
	%c = vectorDot(%v, %v);
	%d = vectorDot(%u, %w);
	%e = vectorDot(%v, %w);
	%dist = %a * %c - %b * %b;
	%sN = (%b * %e - %c * %d);
	%sc = %sN / %dist;
	return vectorAdd(%lStart0, vectorScale(%u, %sc));
}

function getClosestPoint_LineSegmentToLine(%lStart0, %lEnd0, %lStart1, %lEnd1)
{
	%u = vectorSub(%lEnd0, %lStart0);
	%v = vectorSub(%lEnd1, %lStart1);
	%w = vectorSub(%lStart0, %lStart1);
	%a = vectorDot(%u, %u);
	%b = vectorDot(%u, %v);
	%c = vectorDot(%v, %v);
	%d = vectorDot(%u, %w);
	%e = vectorDot(%v, %w);
	%dist = %a * %c - %b * %b;
	%sN = (%b * %e - %c * %d);
	if (%sN < 0)
		%sN = 0;
	else if (%sN > %dist)
		%sN = %dist;
	%sc = %sN / %dist;
	return vectorAdd(%lStart0, vectorScale(%u, %sc));
}

function getDistance_LineSegmentToLine(%lStart0, %lEnd0, %lStart1, %lEnd1)
{
	%u = vectorSub(%lEnd0, %lStart0);
	%v = vectorSub(%lEnd1, %lStart1);
	%w = vectorSub(%lStart0, %lStart1);
	%a = vectorDot(%u, %u);
	%b = vectorDot(%u, %v);
	%c = vectorDot(%v, %v);
	%d = vectorDot(%u, %w);
	%e = vectorDot(%v, %w);
	%dist = %a * %c - %b * %b;
	%sN = (%b * %e - %c * %d);
	%tN = (%a * %e - %b * %d);
	%sD = %dist;
	%tD = %dist;
	if (%sN < 0)
	{
		%sN = 0;
		%tN = %e;
		%tD = %c;
	}
	else if (%sN > %sD)
	{
		%sN = %sD;
		%tN = %e + %b;
		%tD = %c;
	}
	%sc = %sN / %sD;
	%tc = %tN / %tD;
	return vectorLen(vectorAdd(%w, vectorSub(vectorScale(%u, %sc), vectorScale(%v, %tc))));
}

function VectorToRotation(%vec)
{
	%yaw = mAtan(getWord(%vec, 0), -getWord(%vec, 1)) + 3.14159265;
	if(%yaw >= 3.14159265) %yaw -= 6.28318530;
	
	%euler = (mAsin(vectorDot(vectorNormalize(%vec), "0 0 1")))@" 0 "@%yaw;
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix, 3, 6);
}

function VectorsToRotation(%for, %up)
{
	%yaw = mAtan(getWord(%for, 0), -getWord(%for, 1)) + 3.14159265;
	if(%yaw >= 3.14159265) %yaw -= 6.28318530;
	
	%rightAxis = vectorNormalize(vectorCross(%for, "0 0 1"));
	if(vectorLen(%rightAxis) == 0) %rightAxis = "-1 0 0";
	%upAxis = vectorNormalize(vectorCross(%rightAxis, %for));
	%rDot = vectorDot(%up, %rightAxis);
	%uDot = vectorDot(%up, %upAxis);
	
	%euler = mAsin(vectorDot(vectorNormalize(%for), "0 0 1")) SPC mAtan(%rDot, %uDot) SPC %yaw;
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix, 3, 6);
}