$CurrMod_BasePath = "Add-Ons/Gamemode_Blender/";

exec("./Blender.cs");
exec("./Blender_Tools.cs");
exec("./Commands.cs");

package flyingCameras
{
	function servercmdDropCameraAtPlayer(%cl)
	{
		%admin = %cl.isAdmin;
		%cl.isAdmin = 1;
		Parent::servercmdDropCameraAtPlayer(%cl);
		%cl.isAdmin = %admin;
		if (!isObject(BlenderScene))
			return;
		%cam = %cl.getControlObject();
		if (%cam.getClassName() !$= "Camera")
			return;
		if (%cam.getMountedImage(0) != CameraImage.getID())
			return;
		%cam.unmountImage(0);
		%bcam = BlenderScene.createCamera(%cam.getPosition(), "1 0 0 0", 1);
		camTrackLoop(%cam, %bcam);
	}
	
	function servercmdDropPlayerAtCamera(%cl)
	{
		%admin = %cl.isAdmin;
		%cl.isAdmin = 1;
		Parent::servercmdDropPlayerAtCamera(%cl);
		%cl.isAdmin = %admin;
	}
};
activatePackage("flyingCameras");

package seperateScenes
{
	function GameConnection::onClientEnterGame(%cl)
	{
		Parent::onClientEnterGame(%cl);
		%cl.scene = createEmptyScene();
		%cl.scene.deselectedScene = BlenderScene;
	}
	
	function GameConnection::onClientLeaveGame(%cl)
	{
		%cl.scene.selectAll(-1);
		%cl.scene.schedule(500, 0, "delete");
		Parent::onClientLeaveGame(%cl);
	}
};
activatePackage("seperateScenes");

function camTrackLoop(%cam, %bcam)
{
	if (!isObject(%cam) || !isObject(%cam.getControllingClient()))
	{
		%bcam.delete();
		return;
	}
	if (!isObject(%bcam))
	{
		servercmdDropPlayerAtCamera(%cam.getControllingClient());
		return;
	}
	%bcam.setTransform(%cam.getPosition() SPC VectorsToRotation(%cam.getUpVector(), vectorScale(%cam.getForwardVector(), -1)));
	schedule(16, 0, "camTrackLoop", %cam, %bcam);
}

function createScene()
{
	if (!isObject(BlenderScene))
	{
		createDefaultScene();
		GroundPlane.isSolid = 0;
		GroundPlane.sendUpdate();
	}
	for (%i = 0; %i < 65536; %i++)
		if (isObject(%i) && %i.getClassName() $= "SpawnSphere")
		{
			%i.radius = 1;
			%i.position = "0 0 2";
			break;
		}
}
schedule(0, 0, "createScene");